/*****************************************************
 cw 

Project : CW    
Version : 1.01
Date    : 12.11.2013
Author  : Toni                            
Company :  http://www.r4n.su/forum/viewtopic.php?f=27&t=362                            
Comments: 
		      


Chip type           : ATmega8A
Program type        : Application
Clock frequency     : 2,0 MHz
*****************************************************/


#define led 0
#define cw 0  //  cw
#define TIRE 300
#define TOCHKA 100
#define SYMB_PAUSE 300
#define WORD_PAUSE 700
#define R_division 2  //     ,      
#define BEEP_PAUSE 4000 //            
#define PERIOD_BEEP 25 //      = (BEEP_PAUSE/1000)*PERIOD_BEEP  

#include <avr/io.h>
#include <avr/iom8.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>



typedef void func_type (void);
//  

unsigned short count, pause; //    
unsigned char *ptr, cw_str[30]={" VVV BALLON DE RA4NHY "};   //     ,  
unsigned char cw_str_vbatt[16]={" VBATT XXX KKK"};  //    
//void (*func_adr[4])(void);  //       
void (*p)(void);  //   
float float_var;  //  
unsigned int adc;  //  

//---------------FUNCTIONS--------------------------

	void start_timer2(void)
		{
		TIMSK|=1<<TOIE2;  //     
		TCNT2=130; //  
		SFIOR|=1<<PSR2;  //  
		TCCR2|=1<<CS21; //     8
		}
	void stop_timer2(void)
		{
		TCCR2=0;
		TIMSK&=~(1<<TOIE2);
		}
		
	void cw_delay (unsigned short pause)   //      ,      SLEEP,     
		{
			sei();
			start_timer2();
			while(pause)
				{
				sleep_mode();
				pause--;
				}
			stop_timer2();
			cli();
		}


	void tochka(void)
		{
		PORTB|=1<<cw;
		cw_delay(TOCHKA);
		PORTB&=~(1<<cw);
		cw_delay(TOCHKA);
		}

	void tire(void)
		{
		PORTB|=1<<cw;
		cw_delay(TIRE);
		PORTB&=~(1<<cw);
		cw_delay(TOCHKA);
		}

	void bukvA(void)
		{
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvB(void)
		{
		tire();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvC(void)
		{
		tire();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvD(void)
		{
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvE(void)
		{
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvF(void)
		{
		tochka();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvG(void)
		{
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvH(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvI(void)
		{
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvJ(void)
		{
		tochka();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvK(void)
		{
		tire();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvL(void)
		{
		tochka();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvM(void)
		{
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvN(void)
		{
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvO(void)
		{
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvP(void)
		{
		tochka();
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvQ(void)
		{
		tire();
		tire();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvR(void)
		{
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvS(void)
		{
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvT(void)
		{
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvU(void)
		{
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}

	void bukvV(void)
		{
		tochka();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvW(void)
		{
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvX(void)
		{
		tire();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvY(void)
		{
		tire();
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvZ(void)
		{
		tire();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif0(void)
		{
		tire();
		tire();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif1(void)
		{
		tochka();
		tire();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif2(void)
		{
		tochka();
		tochka();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif3(void)
		{
		tochka();
		tochka();
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif4(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif5(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif6(void)
		{
		tire();
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif7(void)
		{
		tire();
		tire();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif8(void)
		{
		tire();
		tire();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif9(void)
		{
		tire();
		tire();
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void space (void)
		{
		PORTB&=~(1<<cw);
		cw_delay(WORD_PAUSE);
		}


func_type* func_adr[37]={bukvA,bukvB,bukvC,bukvD,bukvE,bukvF,bukvG,bukvH,bukvI,bukvG,bukvK,bukvL,bukvM,bukvN,bukvO,bukvP,bukvQ,bukvR,bukvS,bukvT,bukvU,bukvV,bukvW,bukvX,bukvY,bukvZ,cif0,cif1,cif2,cif3,cif4,cif5,cif6,cif7,cif8,cif9,space};


	void cw_tx(unsigned char *ptr)
		{
		unsigned char i=0, i_func_adr;
		while(*(ptr+i))   //     - \0
			{
			if (*(ptr+i)==0) break;
			if (*(ptr+i)==' ') i_func_adr=36;
			
				else
				{
				if (*(ptr+i)>=65) i_func_adr=*(ptr+i)-65;   // 
					else i_func_adr=*(ptr+i)-22;    //  
				}
			p=func_adr[i_func_adr];
			(*p)(); //   
			i++;
			}
		}

	void u_measure(void)  //  
		{
		unsigned char i;
		double voltage=0;
		ADCSRA|=1<<ADEN|1<<ADIE;  // ,    
		sei();
		sleep_mode(); // 
		//  
		cli();
		ADCSRA&=~(1<<ADEN);
		ADCSRA&=~(1<<ADIE);
		voltage=R_division*2.56*adc*1.024; // 
//      
		i=voltage/1000; 
		voltage=voltage-i*1000; 
		cw_str_vbatt[7]=0x30+i;  
		i=voltage/100; 
		voltage=voltage-i*100; 
		cw_str_vbatt[8]=0x30+i;
		i=voltage/10; 
		voltage=voltage-i*10; 
		cw_str_vbatt[9]=0x30+i;
		}


	void beeper (unsigned char i)
		{
		while (i--)
			{
			cw_delay(BEEP_PAUSE);
			bukvS();
			}
		}

// --------------INTERRUPTS---------------------------------------------------------
	ISR(ADC_vect)
		{
		adc=(ADCL|ADCH<<8);  //    
		}

	ISR(TIMER2_OVF_vect)
		{
		TCNT2=130; //  
		SFIOR|=1<<PSR2;  //  
		}


	void main(void)
		{
		DDRC=0x00;  //    
		DDRB=0xFF;  //  
		PORTB=0x00;  //  
		// 
		ADMUX|=1<<REFS1|1<<REFS0|1<<MUX0|1<<MUX1|1<<MUX2;  //  ,   ADC7
		ADCSRA|=1<<ADPS2|1<<ADPS0;  // 32, 125
		set_sleep_mode(SLEEP_MODE_ADC);  //    ,   
		PORTB|=1<<led;
		cw_delay(1000);
		PORTB&=~(1<<led);
		while (1)
			{	
				u_measure();  //   
				cw_tx(cw_str);
				cw_tx(cw_str_vbatt);
				beeper(PERIOD_BEEP);   //    .   S  BEEP_PAUSE 
			}

		}
